<!DOCTYPE html>
<html lang="en">
<head>
        <meta charset="utf-8" />
        <title>Linux And Chill - statistics</title>
        <link rel="stylesheet" href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/theme/css/main.css" />
        <link href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/feeds/all.atom.xml" type="application/atom+xml" rel="alternate" title="Linux And Chill Atom Feed" />
</head>

<body id="index" class="home">
        <header id="banner" class="body">
                <h1><a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/">Linux And Chill </a></h1>
                <nav><ul>
                    <li><a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/category/machine-learning.html">Machine Learning</a></li>
                    <li><a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/category/system-administration.html">System Administration</a></li>
                </ul></nav>
        </header><!-- /#banner -->

            <aside id="featured" class="body">
                <article>
                    <h1 class="entry-title"><a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/reducible-vs-irreducible-error.html">Reducible vs Irreducible Error</a></h1>
<footer class="post-info">
        <abbr class="published" title="2019-05-14T10:20:00-04:00">
                Published: Tue 14 May 2019
        </abbr>

        <address class="vcard author">
                By                         <a class="url fn" href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/author/timothy-pulliam.html">Timothy Pulliam</a>
        </address>
<p>In <a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/category/machine-learning.html">Machine Learning</a>.</p>
<p>tags: <a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/tag/statistics.html">statistics</a> <a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/tag/machine-learning.html">machine learning</a> </p>
</footer><!-- /.post-info --><h3>Statistical Learning Fundamentals</h3>
<p>Consider the following data, which shows relationships between median values of Boston homes in 1978 against three predictors.</p>
<p><img alt="MED vs CRIM" src="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/static/images/reducible-vs-irreducible-error/crim.png"></p>
<p><img alt="MED vs CRIM" src="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/static/images/reducible-vs-irreducible-error/nox.png"></p>
<p><img alt="MED vs CRIM" src="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/static/images/reducible-vs-irreducible-error/ptratio.png"></p>
<p>with dependent variable</p>
<ul>
<li>y = MEDV - Median value of owner-occupied homes in $1000's</li>
</ul>
<p>and independent variables</p>
<ul>
<li><span class="math">\(x_1\)</span> = CRIM - per capita crime rate by town</li>
<li><span class="math">\(x_2\)</span> = NOX - nitric oxides concentration (parts per 10 million)</li>
<li><span class="math">\(x_3\)</span> = PTRATIO - pupil-teacher ratio by town</li>
<li><span class="math">\(X = (x_1,x_2,x_3)\)</span></li>
</ul>
<p>We also recognize that the data points have some inherit uncertainty in their
measurements. This uncertainty or error (<span class="math">\(\epsilon\)</span>), can result from many factors. The
measurements may simply be taken using inaccurate methods or tools. Or it could be that there are other independent variables which we have not
taken into account for our data.</p>
<p>Thus, we have the following relationship</p>
<div class="math">$$Y(x_1, x_2, x_3) = f(x_1, x_2, x_3) + \epsilon$$</div>
<div class="math">$$Y(X) = f(X) + \epsilon$$</div>
<p>Where <span class="math">\(f\)</span> is some unknown function that theoretically captures the data if there were
no error (<span class="math">\(\epsilon\)</span>) in our measurements.</p>
<p><img alt="Underlying Function f(x)" src="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/static/images/reducible-vs-irreducible-error/irreducable_error.png"></p>
<p>In theory, <span class="math">\(\epsilon\)</span> is a random error term and has mean zero.</p>
<p><img alt="Irreducible Error" src="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/static/images/reducible-vs-irreducible-error/error-distribution.png"></p>
<ul>
<li><span class="math">\(Y(X)\)</span> = the data that was collected</li>
<li><span class="math">\(f(X)\)</span> = a theoretical function describing <span class="math">\(Y(x)\)</span></li>
<li><span class="math">\(\epsilon\)</span> = A random error term. It is sometimes called "noise". The errors are
generated at measurement time. Mathematically, it is the difference between our theoretical function and the collected data due to inaccuracies during the data collection process. It is independent of <span class="math">\(X\)</span> and is assumed to have mean 0.</li>
</ul>
<h3>Reducible vs Irreducible Error</h3>
<h5>Deriving Expected Value</h5>
<p>In many cases we are given some X, but we need to know the corresponding <span class="math">\(Y(X)\)</span>.
For this reason, we are interested in obtaining <span class="math">\(f(x)\)</span> (if it is possible) so that we can make accurate predictions for any given input variable. However, in most cases, we
don't know <span class="math">\(f(x)\)</span> and we will not be able to obtain it, since it is obfuscated
behind the random errors. Instead, we guess the function using</p>
<div class="math">$$\hat Y(X) = \hat f(X)$$</div>
<p>where <span class="math">\(\hat f(x)\)</span> is our estimate for the theoretical underlying function <span class="math">\(f(x)\)</span>, and <span class="math">\(\hat Y(X)\)</span> is the resulting prediction of <span class="math">\(Y(X)\)</span>.</p>
<!-- Going Back to our Bostong housing example, we wish to accurately predict the
median value of a home, given some information about the town the home resides in.
We use the following equations

$$Y(X) = f(X) + \epsilon$$
$$\hat Y(X) = \hat f(X)$$ -->

<p>How accurately <span class="math">\(\hat Y(X)\)</span> predicts <span class="math">\(Y(X)\)</span> depends upon <em>reducible error</em> and the
<em>irreducible error</em>. The reducible error is error we have introduced by selecting
<span class="math">\(\hat f(X)\)</span> which does not accurately predict <span class="math">\(Y(X)\)</span>. It is called reducible
because we can reduce it by finding another function that more closely
approximates <span class="math">\(f(X)\)</span>. The irreducible error is the error which resulted at the
time the data was recorded and are reflected in the random <span class="math">\(\epsilon\)</span> term. The
irreducible error term is typically unknown in practice (if we knew the source
of it we might be able to reduce it and it would no longer be irreducible!).
Thus, we are only interested in the reducible error, since it is the only one within
our control.</p>
<p>We can calculate how closely our prediction approximates the data by
calculating the expected value of the square of the difference between them.
That is</p>
<div class="math">$$E \left[ \left( Y(X) - \hat Y(X) \right)^2 \right] = E\left [\left( f(X) + \epsilon - \hat f(X)\right)^2 \right]$$</div>
<div class="math">$$= E \left[ f^2 +f\epsilon - f \hat f + \epsilon f + \epsilon^2 - \hat f \epsilon - \hat f f - \hat f \epsilon + \hat f ^2 \right]$$</div>
<div class="math">$$ = E \left[ (f - \hat f)^2 + \epsilon^2 - 2\epsilon\hat f + 2\epsilon f)\right]$$</div>
<p>If we recall the the Expected Value is a <a href="https://en.wikipedia.org/wiki/Expected_value#Linearity">linear transformation</a> akin to an integral
or summation, we can reduce as follows</p>
<div class="math">$$=E[(f-\hat f)^2] + E \left [\epsilon^2 - 2\epsilon\hat f + 2\epsilon f) \right]$$</div>
<p>If we make the following assumptions</p>
<ul>
<li><span class="math">\(X\)</span> = some constant (then <span class="math">\(\hat f\)</span> and <span class="math">\(f\)</span> are both constants as well)</li>
<li><span class="math">\(\epsilon\)</span> is a random variable</li>
<li><span class="math">\(\epsilon\)</span> does not depend upon <span class="math">\(X\)</span> in any way</li>
<li><span class="math">\(\epsilon\)</span> has expected value (mean) 0</li>
</ul>
<div class="math">$$ E \left [\epsilon^2 - 2\epsilon\hat f + 2\epsilon f) \right] = E[\epsilon^2]
- 2 \hat f E[\epsilon] + 2fE[\epsilon]$$</div>
<p>Noting that the variance of <span class="math">\(\epsilon = E[\epsilon^2] - E[\epsilon]^2 = E[\epsilon^2]\)</span>
We finally have</p>
<div class="math">$$E \left[ \left( Y(X) - \hat Y(X) \right)^2 \right] = \underset{Reducible\ Error}{E[(f-\hat f)^2]} + \underset{Irreducible Error}{Var(\epsilon)}$$</div>
<p>The reducible error term. The closely our estimate <span class="math">\(\hat f\)</span>
approximates the true value of <span class="math">\(f\)</span>, the more accurate our predictions will be</p>
<p>The irreducible error. There is no way we can modify our model
to minimize this error. This effectively puts an upper bounds on how accurate a
Machine Learning model can be.</p>
<script type="text/javascript">if (!document.getElementById('mathjaxscript_pelican_#%@#$@#')) {
    var align = "center",
        indent = "0em",
        linebreak = "false";

    if (false) {
        align = (screen.width < 768) ? "left" : align;
        indent = (screen.width < 768) ? "0em" : indent;
        linebreak = (screen.width < 768) ? 'true' : linebreak;
    }

    var mathjaxscript = document.createElement('script');
    mathjaxscript.id = 'mathjaxscript_pelican_#%@#$@#';
    mathjaxscript.type = 'text/javascript';
    mathjaxscript.src = 'https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.3/latest.js?config=TeX-AMS-MML_HTMLorMML';

    var configscript = document.createElement('script');
    configscript.type = 'text/x-mathjax-config';
    configscript[(window.opera ? "innerHTML" : "text")] =
        "MathJax.Hub.Config({" +
        "    config: ['MMLorHTML.js']," +
        "    TeX: { extensions: ['AMSmath.js','AMSsymbols.js','noErrors.js','noUndefined.js'], equationNumbers: { autoNumber: 'none' } }," +
        "    jax: ['input/TeX','input/MathML','output/HTML-CSS']," +
        "    extensions: ['tex2jax.js','mml2jax.js','MathMenu.js','MathZoom.js']," +
        "    displayAlign: '"+ align +"'," +
        "    displayIndent: '"+ indent +"'," +
        "    showMathMenu: true," +
        "    messageStyle: 'normal'," +
        "    tex2jax: { " +
        "        inlineMath: [ ['\\\\(','\\\\)'] ], " +
        "        displayMath: [ ['$$','$$'] ]," +
        "        processEscapes: true," +
        "        preview: 'TeX'," +
        "    }, " +
        "    'HTML-CSS': { " +
        "        availableFonts: ['STIX', 'TeX']," +
        "        preferredFont: 'STIX'," +
        "        styles: { '.MathJax_Display, .MathJax .mo, .MathJax .mi, .MathJax .mn': {color: 'inherit ! important'} }," +
        "        linebreaks: { automatic: "+ linebreak +", width: '90% container' }," +
        "    }, " +
        "}); " +
        "if ('default' !== 'default') {" +
            "MathJax.Hub.Register.StartupHook('HTML-CSS Jax Ready',function () {" +
                "var VARIANT = MathJax.OutputJax['HTML-CSS'].FONTDATA.VARIANT;" +
                "VARIANT['normal'].fonts.unshift('MathJax_default');" +
                "VARIANT['bold'].fonts.unshift('MathJax_default-bold');" +
                "VARIANT['italic'].fonts.unshift('MathJax_default-italic');" +
                "VARIANT['-tex-mathit'].fonts.unshift('MathJax_default-italic');" +
            "});" +
            "MathJax.Hub.Register.StartupHook('SVG Jax Ready',function () {" +
                "var VARIANT = MathJax.OutputJax.SVG.FONTDATA.VARIANT;" +
                "VARIANT['normal'].fonts.unshift('MathJax_default');" +
                "VARIANT['bold'].fonts.unshift('MathJax_default-bold');" +
                "VARIANT['italic'].fonts.unshift('MathJax_default-italic');" +
                "VARIANT['-tex-mathit'].fonts.unshift('MathJax_default-italic');" +
            "});" +
        "}";

    (document.body || document.getElementsByTagName('head')[0]).appendChild(configscript);
    (document.body || document.getElementsByTagName('head')[0]).appendChild(mathjaxscript);
}
</script>                </article>
            </aside><!-- /#featured -->
        <section id="extras" class="body">
                <div class="blogroll">
                        <h2>links</h2>
                        <ul>
                            <li><a href="http://getpelican.com/">Pelican</a></li>
                            <li><a href="http://python.org/">Python.org</a></li>
                            <li><a href="http://jinja.pocoo.org/">Jinja2</a></li>
                        </ul>
                </div><!-- /.blogroll -->
                <div class="social">
                        <h2>social</h2>
                        <ul>
                            <li><a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/feeds/all.atom.xml" type="application/atom+xml" rel="alternate">atom feed</a></li>

                            <li><a href="https://linkedin.com/in/timothy-pulliam">LinkedIn</a></li>
                            <li><a href="https://github.com/Timothy-Pulliam">Github</a></li>
                            <li><a href="https://www.youtube.com/channel/UC0G4YCuFJukeTicFBO6u4-A?view_as=subscriber">YouTube</a></li>
                        </ul>
                </div><!-- /.social -->
        </section><!-- /#extras -->

        <footer id="contentinfo" class="body">
                <address id="about" class="vcard body">
                Proudly powered by <a href="http://getpelican.com/">Pelican</a>, which takes great advantage of <a href="http://python.org">Python</a>.
                </address><!-- /#about -->

                <p>The theme is by <a href="http://coding.smashingmagazine.com/2009/08/04/designing-a-html-5-layout-from-scratch/">Smashing Magazine</a>, thanks!</p>
        </footer><!-- /#contentinfo -->

</body>
</html>